diff -ruN uppsrc/CodeEditor/CodeEditor.h uppsrc/CodeEditor/CodeEditor.h
--- uppsrc/CodeEditor/CodeEditor.h	2011-11-06 09:29:09 +0600
+++ uppsrc/CodeEditor/CodeEditor.h	2011-11-12 17:22:11 +0600
@@ -179,7 +179,7 @@
 
 	enum {
 		HIGHLIGHT_NONE = -1, HIGHLIGHT_CPP = 0, HIGHLIGHT_USC, HIGHLIGHT_JAVA, HIGHLIGHT_T,
-		HIGHLIGHT_CALC, HIGHLIGHT_SCH, HIGHLIGHT_SQL,
+		HIGHLIGHT_CALC, HIGHLIGHT_LAY, HIGHLIGHT_SCH, HIGHLIGHT_SQL,
 		HIGHLIGHT_COUNT
 	};
 
diff -ruN uppsrc/CodeEditor/Highlight.cpp uppsrc/CodeEditor/Highlight.cpp
--- uppsrc/CodeEditor/Highlight.cpp	2011-11-10 03:08:36 +0600
+++ uppsrc/CodeEditor/Highlight.cpp	2011-11-12 17:35:25 +0600
@@ -373,6 +373,10 @@
 			"koKR", "jaJP",
 			NULL
 		};
+		static const char *lay[] = {
+			"LAYOUT", "ITEM", "UNTYPED", "END_LAYOUT",
+			NULL
+		};
 		static const char *sch[] = {
 			"BIT", "BIT_ARRAY", "BIT_", "BIT_ARRAY_",
 			"BOOL", "BOOL_ARRAY", "BOOL_", "BOOL_ARRAY_",
@@ -412,10 +416,10 @@
 			NULL
 		};
 		static const char **kw[HIGHLIGHT_COUNT] = {
-			cpp, usc, java, tfile, usc, sch, sql
+			cpp, usc, java, tfile, usc, lay, sch, sql
 		};
 		static const char **nm[HIGHLIGHT_COUNT] = {
-			upp, usclib, javan, tlng, usclib, javan, javan
+			upp, usclib, javan, tlng, usclib, javan, javan, javan
 		};
 		const char **q = NULL;
 		for(int i = 0; i < HIGHLIGHT_COUNT; i++) {
diff -ruN uppsrc/ide/idefile.cpp uppsrc/ide/idefile.cpp
--- uppsrc/ide/idefile.cpp	2011-11-08 03:26:22 +0600
+++ uppsrc/ide/idefile.cpp	2011-11-12 18:31:52 +0600
@@ -25,6 +25,9 @@
 		if(ext == ".t" || ext == ".jt")
 			editor.Highlight(CodeEditor::HIGHLIGHT_T);
 		else
+		if(ext == ".lay")
+			editor.Highlight(CodeEditor::HIGHLIGHT_LAY);
+		else
 		if(ext == ".sch")
 			editor.Highlight(CodeEditor::HIGHLIGHT_SCH);
 		else
